package utils

import (
	"reflect"
	"testing"
)

func TestGetUniqueElementsOfStringSlices(t *testing.T) {
	data := []map[string][]string{
		{
			"a":              []string{"apple", "banana", "cherry"},
			"b":              []string{"banana", "cherry", "date", "fig"},
			"expectedResult": []string{"apple"},
		},
		{
			"a":              []string{"banana", "cherry", "date", "fig"},
			"b":              []string{"apple", "banana", "cherry"},
			"expectedResult": []string{"date", "fig"},
		},
		{
			"a":              []string{"apple", "banana", "cherry"},
			"b":              []string{"apple", "banana", "cherry"},
			"expectedResult": []string{},
		},
		{
			"a":              []string{},
			"b":              []string{"apple", "banana", "cherry"},
			"expectedResult": []string{},
		},
		{
			"a":              []string{"apple", "banana", "cherry"},
			"b":              []string{},
			"expectedResult": []string{"apple", "banana", "cherry"},
		},
	}

	for _, test := range data {
		result := GetUniqueElementsOfStringSlices(test["a"], test["b"])
		if !reflect.DeepEqual(result, test["expectedResult"]) {
			if len(result) == 0 && len(test["expectedResult"]) == 0 {
				continue
			}

			t.Errorf("\ngot:    %q\nwanted: %q\nfor:    %q", result, test["expectedResult"], test)
		}
	}
}
